--  C:\08ABR_10H\ACCESO.vhd
--  VHDL code created by Xilinx's StateCAD 6.2i
--  Fri Apr 08 14:48:27 2005

--  This VHDL code (for use with IEEE compliant tools) was generated using: 
--  binary encoded state assignment with structured code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are speed optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY ACCESO IS
	PORT (CLK,BTN0,BTN1,BTN2,BTN3,RESET: IN std_logic;
		AAT,DA,M1,M2 : OUT std_logic);

	SIGNAL BP_AAT,BP_DA,BP_M1,BP_M2: std_logic;
END;

ARCHITECTURE BEHAVIOR OF ACCESO IS
	SIGNAL sreg : std_logic_vector (4 DOWNTO 0);
	SIGNAL next_sreg : std_logic_vector (4 DOWNTO 0);
	CONSTANT AAT_out : std_logic_vector (4 DOWNTO 0) :="00000";
	CONSTANT DA_out : std_logic_vector (4 DOWNTO 0) :="00001";
	CONSTANT INI : std_logic_vector (4 DOWNTO 0) :="00010";
	CONSTANT M1_out : std_logic_vector (4 DOWNTO 0) :="00011";
	CONSTANT M2_out : std_logic_vector (4 DOWNTO 0) :="00100";
	CONSTANT POZO1 : std_logic_vector (4 DOWNTO 0) :="00101";
	CONSTANT POZO2 : std_logic_vector (4 DOWNTO 0) :="00110";
	CONSTANT POZO3 : std_logic_vector (4 DOWNTO 0) :="00111";
	CONSTANT POZO4 : std_logic_vector (4 DOWNTO 0) :="01000";
	CONSTANT SERIE_0 : std_logic_vector (4 DOWNTO 0) :="01001";
	CONSTANT SERIE_1 : std_logic_vector (4 DOWNTO 0) :="01010";
	CONSTANT SERIE_2 : std_logic_vector (4 DOWNTO 0) :="01011";
	CONSTANT SERIE_3 : std_logic_vector (4 DOWNTO 0) :="01100";
	CONSTANT STATE1 : std_logic_vector (4 DOWNTO 0) :="01101";
	CONSTANT STATE2 : std_logic_vector (4 DOWNTO 0) :="01110";
	CONSTANT STATE5 : std_logic_vector (4 DOWNTO 0) :="01111";
	CONSTANT STATE6 : std_logic_vector (4 DOWNTO 0) :="10000";
	CONSTANT STATE9 : std_logic_vector (4 DOWNTO 0) :="10001";
	CONSTANT STATE10 : std_logic_vector (4 DOWNTO 0) :="10010";
	CONSTANT STATE13 : std_logic_vector (4 DOWNTO 0) :="10011";
	CONSTANT STATE14 : std_logic_vector (4 DOWNTO 0) :="10100";

	SIGNAL next_BP_AAT,next_BP_DA,next_BP_M1,next_BP_M2 : std_logic;
BEGIN
	PROCESS (CLK)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			IF ( RESET='1' ) THEN
				sreg <= INI;
			ELSE
				sreg <= next_sreg;
			END IF;
		END IF;
	END PROCESS;

	PROCESS (CLK)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			IF ( RESET='1' ) THEN
				BP_AAT <= '0';
			ELSE
				BP_AAT <= next_BP_AAT;
			END IF;
		END IF;
	END PROCESS;

	PROCESS (CLK)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			IF ( RESET='1' ) THEN
				BP_DA <= '0';
			ELSE
				BP_DA <= next_BP_DA;
			END IF;
		END IF;
	END PROCESS;

	PROCESS (CLK)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			IF ( RESET='1' ) THEN
				BP_M1 <= '0';
			ELSE
				BP_M1 <= next_BP_M1;
			END IF;
		END IF;
	END PROCESS;

	PROCESS (CLK)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			IF ( RESET='1' ) THEN
				BP_M2 <= '0';
			ELSE
				BP_M2 <= next_BP_M2;
			END IF;
		END IF;
	END PROCESS;

	PROCESS (sreg,BP_AAT,BP_DA,BP_M1,BP_M2,BTN0,BTN1,BTN2,BTN3,RESET)
	BEGIN
		next_BP_AAT <= BP_AAT;next_BP_DA <= BP_DA;next_BP_M1 <= BP_M1;next_BP_M2 <=
			 BP_M2;

		next_sreg<=AAT_out;

		IF ( RESET='1' ) THEN
			next_sreg<=INI;
			next_BP_M2<='0';
			next_BP_M1<='0';
			next_BP_DA<='0';
			next_BP_AAT<='0';
		ELSE
			CASE sreg IS
				WHEN AAT_out =>
					next_sreg<=INI;

					IF (( BP_M2='1' )) THEN next_BP_M2<='1';
					ELSE next_BP_M2<='0';
					END IF;

					IF (( BP_M1='1' )) THEN next_BP_M1<='1';
					ELSE next_BP_M1<='0';
					END IF;

					IF (( BP_DA='1' )) THEN next_BP_DA<='1';
					ELSE next_BP_DA<='0';
					END IF;

					IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
					ELSE next_BP_AAT<='0';
					END IF;

				WHEN DA_out =>
					next_sreg<=INI;

					IF (( BP_M2='1' )) THEN next_BP_M2<='1';
					ELSE next_BP_M2<='0';
					END IF;

					IF (( BP_M1='1' )) THEN next_BP_M1<='1';
					ELSE next_BP_M1<='0';
					END IF;

					IF (( BP_DA='1' )) THEN next_BP_DA<='1';
					ELSE next_BP_DA<='0';
					END IF;

					IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
					ELSE next_BP_AAT<='0';
					END IF;

				WHEN INI =>
					IF ( BTN2='0' AND BTN1='0' AND BTN0='0' AND BTN3='0' ) THEN
						next_sreg<=INI;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN2='1' ) THEN
						next_sreg<=SERIE_2;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN1='1' ) THEN
						next_sreg<=SERIE_1;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN0='1' ) THEN
						next_sreg<=SERIE_0;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN3='1' ) THEN
						next_sreg<=SERIE_3;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN M1_out =>
					next_sreg<=INI;

					IF (( BP_M2='1' )) THEN next_BP_M2<='1';
					ELSE next_BP_M2<='0';
					END IF;

					IF (( BP_M1='1' )) THEN next_BP_M1<='1';
					ELSE next_BP_M1<='0';
					END IF;

					IF (( BP_DA='1' )) THEN next_BP_DA<='1';
					ELSE next_BP_DA<='0';
					END IF;

					IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
					ELSE next_BP_AAT<='0';
					END IF;

				WHEN M2_out =>
					next_sreg<=INI;

					IF (( BP_M2='1' )) THEN next_BP_M2<='1';
					ELSE next_BP_M2<='0';
					END IF;

					IF (( BP_M1='1' )) THEN next_BP_M1<='1';
					ELSE next_BP_M1<='0';
					END IF;

					IF (( BP_DA='1' )) THEN next_BP_DA<='1';
					ELSE next_BP_DA<='0';
					END IF;

					IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
					ELSE next_BP_AAT<='0';
					END IF;

				WHEN POZO1 =>
					next_sreg<=POZO2;

					IF (( BP_M2='1' )) THEN next_BP_M2<='1';
					ELSE next_BP_M2<='0';
					END IF;

					IF (( BP_M1='1' )) THEN next_BP_M1<='1';
					ELSE next_BP_M1<='0';
					END IF;

					IF (( BP_DA='1' )) THEN next_BP_DA<='1';
					ELSE next_BP_DA<='0';
					END IF;

					IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
					ELSE next_BP_AAT<='0';
					END IF;

				WHEN POZO2 =>
					next_sreg<=POZO3;

					IF (( BP_M2='1' )) THEN next_BP_M2<='1';
					ELSE next_BP_M2<='0';
					END IF;

					IF (( BP_M1='1' )) THEN next_BP_M1<='1';
					ELSE next_BP_M1<='0';
					END IF;

					IF (( BP_DA='1' )) THEN next_BP_DA<='1';
					ELSE next_BP_DA<='0';
					END IF;

					IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
					ELSE next_BP_AAT<='0';
					END IF;

				WHEN POZO3 =>
					next_sreg<=POZO4;

					IF (( BP_M2='1' )) THEN next_BP_M2<='1';
					ELSE next_BP_M2<='0';
					END IF;

					IF (( BP_M1='1' )) THEN next_BP_M1<='1';
					ELSE next_BP_M1<='0';
					END IF;

					IF (( BP_DA='1' )) THEN next_BP_DA<='1';
					ELSE next_BP_DA<='0';
					END IF;

					IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
					ELSE next_BP_AAT<='0';
					END IF;

				WHEN POZO4 =>
					next_sreg<=INI;

					IF (( BP_M2='1' )) THEN next_BP_M2<='1';
					ELSE next_BP_M2<='0';
					END IF;

					IF (( BP_M1='1' )) THEN next_BP_M1<='1';
					ELSE next_BP_M1<='0';
					END IF;

					IF (( BP_DA='1' )) THEN next_BP_DA<='1';
					ELSE next_BP_DA<='0';
					END IF;

					IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
					ELSE next_BP_AAT<='0';
					END IF;

				WHEN SERIE_0 =>
					IF ( BTN3='1' ) THEN
						next_sreg<=STATE1;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN3='0' ) THEN
						next_sreg<=POZO1;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN SERIE_1 =>
					IF ( BTN0='0' ) THEN
						next_sreg<=POZO1;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN0='1' ) THEN
						next_sreg<=STATE5;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN SERIE_2 =>
					IF ( BTN3='0' ) THEN
						next_sreg<=POZO1;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN3='1' ) THEN
						next_sreg<=STATE9;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN SERIE_3 =>
					IF ( BTN1='0' ) THEN
						next_sreg<=POZO1;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN1='1' ) THEN
						next_sreg<=STATE13;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN STATE1 =>
					IF ( BTN2='0' ) THEN
						next_sreg<=POZO2;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN2='1' ) THEN
						next_sreg<=STATE2;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN STATE2 =>
					IF ( BTN1='1' ) THEN
						next_sreg<=M1_out;
						next_BP_M1<='1';

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN1='0' ) THEN
						next_sreg<=POZO3;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN STATE5 =>
					IF ( BTN3='0' ) THEN
						next_sreg<=POZO2;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN3='1' ) THEN
						next_sreg<=STATE6;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN STATE6 =>
					IF ( BTN2='1' ) THEN
						next_sreg<=M2_out;
						next_BP_M2<='1';

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN2='0' ) THEN
						next_sreg<=POZO3;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN STATE9 =>
					IF ( BTN0='0' ) THEN
						next_sreg<=POZO2;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN0='1' ) THEN
						next_sreg<=STATE10;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN STATE10 =>
					IF ( BTN1='1' ) THEN
						next_sreg<=AAT_out;
						next_BP_AAT<='1';

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

					END IF;
					IF ( BTN1='0' ) THEN
						next_sreg<=POZO3;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN STATE13 =>
					IF ( BTN0='0' ) THEN
						next_sreg<=POZO2;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN0='1' ) THEN
						next_sreg<=STATE14;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN STATE14 =>
					IF ( BTN1='1' ) THEN
						next_sreg<=DA_out;
						next_BP_DA<='1';

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
					IF ( BTN1='0' ) THEN
						next_sreg<=POZO3;

						IF (( BP_M2='1' )) THEN next_BP_M2<='1';
						ELSE next_BP_M2<='0';
						END IF;

						IF (( BP_M1='1' )) THEN next_BP_M1<='1';
						ELSE next_BP_M1<='0';
						END IF;

						IF (( BP_DA='1' )) THEN next_BP_DA<='1';
						ELSE next_BP_DA<='0';
						END IF;

						IF (( BP_AAT='1' )) THEN next_BP_AAT<='1';
						ELSE next_BP_AAT<='0';
						END IF;

					END IF;
				WHEN OTHERS =>
			END CASE;
		END IF;
	END PROCESS;

	PROCESS (BP_AAT)
	BEGIN
		IF (( BP_AAT='1' )) THEN AAT<='1';
		ELSE AAT<='0';
		END IF;
	END PROCESS;

	PROCESS (BP_DA)
	BEGIN
		IF (( BP_DA='1' )) THEN DA<='1';
		ELSE DA<='0';
		END IF;
	END PROCESS;

	PROCESS (BP_M1)
	BEGIN
		IF (( BP_M1='1' )) THEN M1<='1';
		ELSE M1<='0';
		END IF;
	END PROCESS;

	PROCESS (BP_M2)
	BEGIN
		IF (( BP_M2='1' )) THEN M2<='1';
		ELSE M2<='0';
		END IF;
	END PROCESS;
END BEHAVIOR;
