library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ssegcontrol is
    Port ( CLK  : in  std_logic; 
           BCD3 : in  std_logic_vector(3 downto 0);
           BCD2 : in  std_logic_vector(3 downto 0);
           BCD1 : in  std_logic_vector(3 downto 0);
           BCD0 : in  std_logic_vector(3 downto 0);		 
		 		 
           DIG  : out std_logic_vector(6 downto 0);
		 AN   : out std_logic_vector(3 downto 0)
		);
end ssegcontrol;

architecture Behavioral of ssegcontrol is      
	signal BCD  : std_logic_vector(3 downto 0);	
	signal CNT  : std_logic_vector(15 downto 0);
	signal SEL  : std_logic_vector(1 downto 0);
begin


   -- Comptador
   process(CLK)
   begin
      if CLK'event and CLK='0' then
	    CNT <= CNT + 1;
      end if;
   end process;
   SEL(1 downto 0) <= CNT(15 downto 14);
      
   -- Multiplexor
   process (SEL, BCD3, BCD2, BCD1, BCD0)
   begin
      case SEL is
         when "00" => BCD <= BCD0;
	                 AN  <= "1111";
         when "01" => BCD <= BCD1;
	                 AN  <= "1101";
         when "10" => BCD <= BCD2;
	                 AN  <= "1011";
         when "11" => BCD <= BCD3;
	                 AN  <= "0111";
	    when others => NULL;
      end case;	
   end process; 
	 
   -- Hex2led
   with BCD SELect
   DIG<= "1111001" when "0001",   --1
         "0100100" when "0010",   --2
         "0110000" when "0011",   --3
         "0011001" when "0100",   --4
         "0010010" when "0101",   --5
         "0000010" when "0110",   --6
         "1111000" when "0111",   --7
         "0000000" when "1000",   --8
         "0010000" when "1001",   --9
         "0001000" when "1010",   --A
         "0000011" when "1011",   --b
         "1000110" when "1100",   --C
         "0100001" when "1101",   --d
         "0000110" when "1110",   --E
         "0001110" when "1111",   --F
         "1000000" when others;   --0	  	     

end Behavioral;
