library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity multipleclock is
    Port ( clk      : in std_logic;

           clk25Mhz : out std_logic;
		 clk50Khz : out std_logic;
		 clk24hz  : out std_logic;
		 clk1hz   : out std_logic);
end multipleclock;

architecture Behavioral of multipleclock is
	signal cnt1 : std_logic_vector(25 downto 0);
	signal cnt2 : std_logic_vector(26 downto 0);
	signal neg  : std_logic;
begin

	process(clk)
	begin	     
		if clk'event and clk = '0' then
			cnt1 <= cnt1 + 1;			
			cnt2 <= cnt2 + 1;
		end if;
		if cnt1 = "10111110101111000010000000" then
			cnt1 <= "00000000000000000000000000";
			neg <= not neg;			
		end if;          
	end process;

	clk25Mhz <= cnt2(1);
	clk50Khz <= cnt2(10);
	clk24hz <= cnt2(21);
	clk1hz <= neg;

end Behavioral;
