library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity dbounce is
    Port ( clk : in std_logic;
           key : in std_logic;
           pulse : out std_logic);
end dbounce;

architecture Behavioral of dbounce is
   signal cnt : std_logic_vector(7 downto 0);
begin

   process(clk)
   begin
      if key = '1' then
	    cnt <= "00000000";
      elsif (clk'event and clk = '1') then
	    if (cnt /= "11111111") then
	       cnt <= cnt + 1;
         end if;
      end if;
	 if (cnt > "10000000") and (key = '0') then
	    pulse <= '0';
      else
	    pulse <= '1';
      end if;
   end process;
end Behavioral;
