--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 6.3.03i
--  \   \         Application : 
--  /   /         Filename : top.vhf
-- /___/   /\     Timestamp : 04/08/2005 17:34:14
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: top
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.ALL;
-- synopsys translate_on

entity top is
   port ( AP       : in    std_logic; 
          BTN0     : in    std_logic; 
          BTN1     : in    std_logic; 
          BTN2     : in    std_logic; 
          BTN3     : in    std_logic; 
          CLK_50Hz : in    std_logic; 
          PP       : in    std_logic; 
          RESET    : in    std_logic; 
          SA       : in    std_logic; 
          SF       : in    std_logic; 
          SG       : in    std_logic; 
          LED1     : out   std_logic; 
          LED2     : out   std_logic; 
          SENYAL   : out   std_logic);
end top;

architecture BEHAVIORAL of top is
   signal CLK_1Hz  : std_logic;
   signal DA       : std_logic;
   signal XLXN_93  : std_logic;
   signal XLXN_96  : std_logic;
   signal XLXN_97  : std_logic;
   signal XLXN_98  : std_logic;
   signal XLXN_102 : std_logic;
   signal XLXN_106 : std_logic;
   signal XLXN_112 : std_logic_vector (3 downto 0);
   signal XLXN_113 : std_logic_vector (3 downto 0);
   signal XLXN_114 : std_logic_vector (1 downto 0);
   signal XLXN_135 : std_logic;
   signal XLXN_147 : std_logic;
   signal XLXN_148 : std_logic;
   signal XLXN_149 : std_logic;
   signal XLXN_150 : std_logic;
   signal XLXN_153 : std_logic;
   signal XLXN_154 : std_logic;
   component multipleclock
      port ( clk      : in    std_logic; 
             clk25Mhz : out   std_logic; 
             clk50Khz : out   std_logic; 
             clk24hz  : out   std_logic; 
             clk1hz   : out   std_logic);
   end component;
   
   component llamadas
      port ( CLK              : in    std_logic; 
             empieza_a_llamar : in    std_logic; 
             RESET            : in    std_logic; 
             cifra_mem        : in    std_logic_vector (3 downto 0); 
             fin_llamada      : out   std_logic; 
             senyal           : out   std_logic; 
             columna          : out   std_logic_vector (3 downto 0));
   end component;
   
   component dbounce
      port ( clk   : in    std_logic; 
             key   : in    std_logic; 
             pulse : out   std_logic);
   end component;
   
   component nucleo
      port ( CLK              : in    std_logic; 
             AAT              : in    std_logic; 
             AP               : in    std_logic; 
             DA               : in    std_logic; 
             fin_llamada      : in    std_logic; 
             M1               : in    std_logic; 
             M2               : in    std_logic; 
             PP               : in    std_logic; 
             RESET            : in    std_logic; 
             SA               : in    std_logic; 
             SF               : in    std_logic; 
             SG               : in    std_logic; 
             TOFF             : in    std_logic; 
             empieza_a_llamar : out   std_logic; 
             LED1             : out   std_logic; 
             LED2             : out   std_logic; 
             T1ON             : out   std_logic; 
             T2ON             : out   std_logic; 
             TIPO_CALL        : out   std_logic_vector (1 downto 0));
   end component;
   
   component timer
      port ( CLK        : in    std_logic; 
             T1ON       : in    std_logic; 
             T2ON       : in    std_logic; 
             FIN_CUENTA : out   std_logic);
   end component;
   
   component memoria
      port ( TIPO_CALL : in    std_logic_vector (1 downto 0); 
             COLUMNA   : in    std_logic_vector (3 downto 0); 
             CIFRA_MEM : out   std_logic_vector (3 downto 0));
   end component;
   
   component acceso
      port ( CLK   : in    std_logic; 
             BTN0  : in    std_logic; 
             BTN1  : in    std_logic; 
             BTN2  : in    std_logic; 
             BTN3  : in    std_logic; 
             RESET : in    std_logic; 
             AAT   : out   std_logic; 
             DA    : out   std_logic; 
             M1    : out   std_logic; 
             M2    : out   std_logic);
   end component;
   
begin
   XLXI_13 : multipleclock
      port map (clk=>CLK_50Hz,      
                clk1hz=>CLK_1Hz,      
                clk24hz=>XLXN_135,      
                clk25Mhz=>open,      
                clk50Khz=>open);
   
   XLXI_41 : llamadas
      port map (cifra_mem(3 downto 0)=>XLXN_112(3 downto 0),      
                CLK=>XLXN_135,      
                empieza_a_llamar=>XLXN_98,      
                RESET=>RESET,      
                columna(3 downto 0)=>XLXN_113(3 downto 0),      
                fin_llamada=>XLXN_106,      
                senyal=>SENYAL);
   
   XLXI_43 : dbounce
      port map (clk=>CLK_1Hz,      
                key=>BTN3,      
                pulse=>XLXN_150);
   
   XLXI_44 : dbounce
      port map (clk=>CLK_1Hz,      
                key=>BTN0,      
                pulse=>XLXN_147);
   
   XLXI_45 : dbounce
      port map (clk=>CLK_1Hz,      
                key=>BTN1,      
                pulse=>XLXN_148);
   
   XLXI_46 : dbounce
      port map (clk=>CLK_1Hz,      
                key=>BTN2,      
                pulse=>XLXN_149);
   
   XLXI_47 : nucleo
      port map (AAT=>XLXN_93,      
                AP=>AP,      
                CLK=>CLK_50Hz,      
                DA=>DA,      
                fin_llamada=>XLXN_106,      
                M1=>XLXN_153,      
                M2=>XLXN_154,      
                PP=>PP,      
                RESET=>RESET,      
                SA=>SA,      
                SF=>SF,      
                SG=>SG,      
                TOFF=>XLXN_102,      
                empieza_a_llamar=>XLXN_98,      
                LED1=>LED1,      
                LED2=>LED2,      
                TIPO_CALL(1 downto 0)=>XLXN_114(1 downto 0),      
                T1ON=>XLXN_97,      
                T2ON=>XLXN_96);
   
   XLXI_48 : timer
      port map (CLK=>CLK_1Hz,      
                T1ON=>XLXN_97,      
                T2ON=>XLXN_96,      
                FIN_CUENTA=>XLXN_102);
   
   XLXI_49 : memoria
      port map (COLUMNA(3 downto 0)=>XLXN_113(3 downto 0),      
                TIPO_CALL(1 downto 0)=>XLXN_114(1 downto 0),      
                CIFRA_MEM(3 downto 0)=>XLXN_112(3 downto 0));
   
   XLXI_55 : acceso
      port map (BTN0=>XLXN_147,      
                BTN1=>XLXN_148,      
                BTN2=>XLXN_149,      
                BTN3=>XLXN_150,      
                CLK=>CLK_1Hz,      
                RESET=>RESET,      
                AAT=>XLXN_93,      
                DA=>DA,      
                M1=>XLXN_153,      
                M2=>XLXN_154);
   
end BEHAVIORAL;


